Index: squid/doc/Programming-Guide/prog-guide.sgml
===================================================================
RCS file: /cvsroot/squid-sf//squid/doc/Programming-Guide/prog-guide.sgml,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/doc/Programming-Guide/prog-guide.sgml	26 Jan 2000 03:23:10 -0000	1.1.1.1
+++ squid/doc/Programming-Guide/prog-guide.sgml	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -568,141 +427,143 @@
 	we prefer to have the smaller and simpler <em/pinger/
 	program installed with setuid permissions.
 	</enum>
-	
-<sect2>unlinkd
-<P>
-<em/Files:/
-	<tt/unlinkd.c/
 
-<P>
+<sect1>unlinkd
+
+	<P>
 	The <tt/unlink(2)/ system call can cause a process to block
 	for a significant amount of time.  Therefore we do not want
 	to make unlink() calls from Squid.  Instead we pass them
 	to this external process.
 
-<sect2>redirector
-
-<P>
-<em/Files:/
-	user-developed
+<sect1>redirector
 
-<P>
+	<P>
 	A redirector process reads URLs on stdin and writes (possibly
 	changed) URLs on stdout.  It is implemented as an external
 	process to maximize flexibility.
 
-<sect1>Sequence of a Typical Request
+<sect>Flow of a Typical Request
 
-<P>
-<enum>
-<item>
-A client connection is accepted by the <em/client-side/.  The HTTP request
-is parsed.
-
-<item>
-The access controls are checked.  The client-side builds an
-ACL state data structure and registers a callback function
-for notification when access control checking is completed.
-
-<item>
-After the access controls have been verified, the client-side looks for
-the requested object in the cache.  If is a cache hit, then the
-client-side registers its interest in the <em/StoreEntry/.  Otherwise,
-Squid needs to forward the request, perhaps with an If-Modified-Since
-header.
-
-<item>
-The request-forwarding process begins with <tt/protoDispatch/.
-This function begins the peer selection procedure, which may
-involve sending ICP queries and receiving ICP replies.  The peer
-selection procedure also involves checking configuration
-options such as <em/never_direct/ and <em/always_direct/.
-
-<item>
-When the ICP replies (if any) have been processed, we end up
-at <em/protoStart/.  This function calls an appropriate 
-protocol-specific function for forwarding the request.  Here we
-will assume it is an HTTP request.
-
-<item>
-The HTTP module first opens a connection to the origin server
-or cache peer.  If there is no idle persistent socket available,
-a new connection request is given to the Network Communication
-module with a callback function.  The <tt/comm.c/ routines
-may try establishing a connection multiple times before giving up.
-
-<item>
-When a TCP connection has been established, HTTP builds a request
-buffer and submits it for writing on the socket.  It then registers
-a read handler to receive and process the HTTP reply.
-
-<item>
-As the reply is initially received, the HTTP reply headers are
-parsed and placed into a reply data structure.  As reply data
-is read, it is appended to the <em/StoreEntry/.  Every time data
-is appended to the <em/StoreEntry/, the client-side is 
-notified of the new data via a callback function.
-
-<item>
-As the client-side is notified of new data, it copies the data
-from the StoreEntry and submits it for writing on the client socket.
-
-<item>
-As data is appended to the <em/StoreEntry/, and the client(s)
-read it, the data may be submitted for writing to disk.
-
-<item>
-When the HTTP module finishes reading the reply from the upstream
-server, it marks the <em/StoreEntry/ as ``complete.''  The server
-socket is either closed or given to the persistent connection pool
-for future use.
-
-<item>
-When the client-side has written all of the object data, it unregisters
-itself from the <em/StoreEntry/.  At the same time it either waits for
-another request from the client, or closes the client connection.
+	<P>
+	<enum>
+	<item>
+	A client connection is accepted by the <em/client-side/.
+	The HTTP request is parsed.
+
+	<item>
+	The access controls are checked.  The client-side builds
+	an ACL state data structure and registers a callback function
+	for notification when access control checking is completed.
+
+	<item>
+	After the access controls have been verified, the client-side
+	looks for the requested object in the cache.  If is a cache
+	hit, then the client-side registers its interest in the
+	<em/StoreEntry/.  Otherwise, Squid needs to forward the
+	request, perhaps with an If-Modified-Since header.
+
+	<item>
+	The request-forwarding process begins with <tt/protoDispatch/.
+	This function begins the peer selection procedure, which
+	may involve sending ICP queries and receiving ICP replies.
+	The peer selection procedure also involves checking
+	configuration options such as <em/never_direct/ and
+	<em/always_direct/.
+
+	<item>
+	When the ICP replies (if any) have been processed, we end
+	up at <em/protoStart/.  This function calls an appropriate
+	protocol-specific function for forwarding the request.
+	Here we will assume it is an HTTP request.
+
+	<item>
+	The HTTP module first opens a connection to the origin
+	server or cache peer.  If there is no idle persistent socket
+	available, a new connection request is given to the Network
+	Communication module with a callback function.  The
+	<tt/comm.c/ routines may try establishing a connection
+	multiple times before giving up.
+
+	<item>
+	When a TCP connection has been established, HTTP builds a
+	request buffer and submits it for writing on the socket.
+	It then registers a read handler to receive and process
+	the HTTP reply.
+
+	<item>
+	As the reply is initially received, the HTTP reply headers
+	are parsed and placed into a reply data structure.  As
+	reply data is read, it is appended to the <em/StoreEntry/.
+	Every time data is appended to the <em/StoreEntry/, the
+	client-side is notified of the new data via a callback
+	function.
+
+	<item>
+	As the client-side is notified of new data, it copies the
+	data from the StoreEntry and submits it for writing on the
+	client socket.
+
+	<item>
+	As data is appended to the <em/StoreEntry/, and the client(s)
+	read it, the data may be submitted for writing to disk.
+
+	<item>
+	When the HTTP module finishes reading the reply from the
+	upstream server, it marks the <em/StoreEntry/ as ``complete.''
+	The server socket is either closed or given to the persistent
+	connection pool for future use.
+
+	<item>
+	When the client-side has written all of the object data,
+	it unregisters itself from the <em/StoreEntry/.  At the
+	same time it either waits for another request from the
+	client, or closes the client connection.
 
-</enum>
+	</enum>
 
-<!-- %%%% Chapter : MAIN LOOP %%%% -->
-<sect>The Main Loop: <tt/comm_select()/
+<sect>Callback Functions
 
-<P>
-At the core of Squid is the <tt/select(2)/ system call.  Squid uses
-<tt/select()/ or <tt/poll(2)/ to process I/O on all open file descriptors.
-Hereafter we'll only use ``select'' to refer generically to either system call.
+<sect>The Main Loop: <tt/comm_select()/
 
-<P>
-The <tt/select()/ and <tt/poll()/ system calls work by waiting for
-I/O events on a set of file descriptors.  Squid only checks for
-<em/read/ and <em/write/ events. Squid knows that it should
-check for reading or writing when there
-is a read or write handler registered for a given file descriptor.  
-Handler functions are registered with the <tt/commSetSelect/ function.
-For example:
+	<P>
+	At the core of Squid is the <tt/select(2)/ system call.
+	Squid uses <tt/select()/ or <tt/poll(2)/ to process I/O on
+	all open file descriptors.  Hereafter we'll only use
+	``select'' to refer generically to either system call.
+
+	<P>
+	The <tt/select()/ and <tt/poll()/ system calls work by
+	waiting for I/O events on a set of file descriptors.  Squid
+	only checks for <em/read/ and <em/write/ events. Squid
+	knows that it should check for reading or writing when
+	there is a read or write handler registered for a given
+	file descriptor.  Handler functions are registered with
+	the <tt/commSetSelect/ function.  For example:
 <verb>
 	commSetSelect(fd, COMM_SELECT_READ, clientReadRequest, conn, 0);
 </verb>
-In this example, <em/fd/ is a TCP socket to a client connection.
-When there is data to be read from the socket, then the select loop
-will execute
+	In this example, <em/fd/ is a TCP socket to a client
+	connection.  When there is data to be read from the socket,
+	then the select loop will execute
 <verb>
 	clientReadRequest(fd, conn);
 </verb>
 
-<P>
-The I/O handlers are reset every time they are called.  In other words,
-a handler function must re-register itself with <tt/commSetSelect/
-if it wants to continue reading or writing on a file descriptor.
-The I/O handler may be canceled before being called by providing
-NULL arguments, e.g.:
+	<P>
+	The I/O handlers are reset every time they are called.  In
+	other words, a handler function must re-register itself
+	with <tt/commSetSelect/ if it wants to continue reading or
+	writing on a file descriptor.  The I/O handler may be
+	canceled before being called by providing NULL arguments,
+	e.g.:
 <verb>
 	commSetSelect(fd, COMM_SELECT_READ, NULL, NULL, 0);
 </verb>
 
-<P>
-These I/O handlers (and others) and their associated callback data
-pointers are saved in the <em/fde/ data structure:
+	<P>
+	These I/O handlers (and others) and their associated callback
+	data pointers are saved in the <em/fde/ data structure:
 <verb>
 	struct _fde {
 		...
@@ -715,81 +576,558 @@
 		void *defer_data;
 	};
 </verb>
-<em/read_handler/ and <em/write_handler/ are called when the file
-descriptor is ready for reading or writing, respectively.  
-The <em/close_handler/ is called when the filedescriptor
-is closed.   The <em/close_handler/ is actually a linked list
-of callback functions to be called.
-
-<P>
-In some situations we want to defer reading from a filedescriptor,
-even though it has data for us to read.  This may be the case
-when data arrives from the server-side faster than it can 
-be written to the client-side.
-Before adding a filedescriptor to the ``read set'' for select,
-we call <em/defer_check/ (if it is non-NULL).  If <em/defer_check/
-returns 1, then we skip the filedescriptor for that time through
-the select loop.
+	<em/read_handler/ and <em/write_handler/ are called when
+	the file descriptor is ready for reading or writing,
+	respectively.  The <em/close_handler/ is called when the
+	filedescriptor is closed.   The <em/close_handler/ is
+	actually a linked list of callback functions to be called.
+
+	<P>
+	In some situations we want to defer reading from a
+	filedescriptor, even though it has data for us to read.
+	This may be the case when data arrives from the server-side
+	faster than it can be written to the client-side.  Before
+	adding a filedescriptor to the ``read set'' for select, we
+	call <em/defer_check/ (if it is non-NULL).  If <em/defer_check/
+	returns 1, then we skip the filedescriptor for that time
+	through the select loop.
 
 
 
-<P>
-These handlers are stored in the <em/FD_ENTRY/ structure as defined in
-<tt/comm.h/.  <tt/fd_table[]/ is the global array of <em/FD_ENTRY/
-structures.  The handler functions are of type <em/PF/, which is a
-typedef:
+	<P>
+	These handlers are stored in the <em/FD_ENTRY/ structure
+	as defined in <tt/comm.h/.  <tt/fd_table[]/ is the global
+	array of <em/FD_ENTRY/ structures.  The handler functions
+	are of type <em/PF/, which is a typedef:
 <verb>
     typedef void (*PF) (int, void *);
 </verb>
-The close handler is really a linked list of handler functions.
-Each handler also has an associated pointer <tt/(void *data)/ to
-some kind of data structure.
+	The close handler is really a linked list of handler
+	functions.  Each handler also has an associated pointer
+	<tt/(void *data)/ to some kind of data structure.
+
+	<P>
+	<tt/comm_select()/ is the function which issues the select()
+	system call.  It scans the entire <tt/fd_table[]/ array
+	looking for handler functions.  Each file descriptor with
+	a read handler will be set in the <tt/fd_set/ read bitmask.
+	Similarly, write handlers are scanned and bits set for the
+	write bitmask.  <tt/select()/ is then called, and the return
+	read and write bitmasks are scanned for descriptors with
+	pending I/O.  For each ready descriptor, the handler is
+	called.  Note that the handler is cleared from the
+	<em/FD_ENTRY/ before it is called.
+
+	<P>
+	After each handler is called, <tt/comm_select_incoming()/
+	is called to process new HTTP and ICP requests.
+
+	<P>
+	Typical read handlers are
+	<tt/httpReadReply()/,
+	<tt/diskHandleRead()/,
+	<tt/icpHandleUdp()/,
+	and <tt/ipcache_dnsHandleRead()/.
+	Typical write handlers are
+	<tt/commHandleWrite()/,
+	<tt/diskHandleWrite()/,
+	and <tt/icpUdpReply()/.
+	The handler function is set with <tt/commSetSelect()/, with the
+	exception of the close handlers, which are set with
+	<tt/comm_add_close_handler()/.
+
+	<P>
+	The close handlers are normally called from <tt/comm_close()/.
+	The job of the close handlers is to deallocate data structures
+	associated with the file descriptor.  For this reason
+	<tt/comm_close()/ must normally be the last function in a
+	sequence to prevent accessing just-freed memory.
+
+	<P>
+	The timeout and lifetime handlers are called for file
+	descriptors which have been idle for too long.  They are
+	further discussed in a following chapter.
 
-<P>
-<tt/comm_select()/ is the function which issues the select() system
-call.  It scans the entire <tt/fd_table[]/ array looking for handler
-functions.  Each file descriptor with a read handler will be set in
-the <tt/fd_set/ read bitmask.  Similarly, write handlers are scanned and
-bits set for the write bitmask.  <tt/select()/ is then called, and the
-return read and write bitmasks are scanned for descriptors with pending
-I/O.  For each ready descriptor, the handler is called.  Note that
-the handler is cleared from the <em/FD_ENTRY/ before it is called.
+<!-- %%%% Chapter : CLIENT REQUEST PROCESSING %%%% -->
+<sect>Processing Client Requests
 
-<P>
-After each handler is called, <tt/comm_select_incoming()/ is
-called to process new HTTP and ICP requests.
+<!-- %%%% Chapter : STORAGE MANAGER %%%% -->
+<sect>Storage Manager
 
-<P>
-Typical read handlers are
-<tt/httpReadReply()/,
-<tt/diskHandleRead()/,
-<tt/icpHandleUdp()/,
-and <tt/ipcache_dnsHandleRead()/.
-Typical write handlers are
-<tt/commHandleWrite()/,
-<tt/diskHandleWrite()/,
-and <tt/icpUdpReply()/.
-The handler function is set with <tt/commSetSelect()/, with the
-exception of the close handlers, which are set with
-<tt/comm_add_close_handler()/.
+<!-- %%%% Chapter : FILESYSTEM INTERFACE %%%% -->
+<sect>Filesystem Interface
 
-<P>
-The close handlers are normally called from <tt/comm_close()/.  
-The job of the close handlers is to deallocate data structures 
-associated with the file descriptor.  For this reason <tt/comm_close()/
-must normally be the last function in a sequence to prevent accessing
-just-freed memory.
+<sect1>Introduction
 
-<P>
-The timeout and lifetime handlers are called for file descriptors which
-have been idle for too long.  They are further discussed in a following 
-chapter.
+	<P>
+	Traditionally, Squid has always used the Unix filesystem (UFS)
+	to store cache objects on disk.  Over the years, the
+	poor performance of UFS has become very obvious.  In most
+	cases, UFS limits Squid to about 30-50 requests per second.
+	Our work indicates that the poor performance is mostly
+	due to the synchronous nature of <tt/open()/ and <tt/unlink()/
+	system calls, and perhaps thrashing of inode/buffer caches.
+
+	<P>
+	We want to try out our own, customized filesystems with Squid.
+	In order to do that, we need a well-defined interface
+	for the bits of Squid that access the permanent storage
+	devices.
+
+<sect1>The Interface
+
+<sect2>Data Structures
+
+<sect3><em/storeIOState/
+
+	<P>
+	Every cache object that is ``opened'' for reading or writing
+	will have a <em/storeIOState/ data structure associated with
+	it.  Currently, this structure looks like:
+<verb>
+        struct _storeIOState {
+            sfileno swap_file_number;
+            mode_t mode;
+            size_t st_size;             /* do stat(2) after read open */
+            off_t offset;               /* current offset pointer */
+            STIOCB *callback;
+            void *callback_data;
+            struct {
+                STRCB *callback;
+                void *callback_data;
+            } read;
+            struct {
+                unsigned int closing:1; /* debugging aid */
+            } flags;
+            union {
+                struct {
+                    int fd;
+                    struct {
+                        unsigned int close_request:1;
+                        unsigned int reading:1;
+                        unsigned int writing:1;
+                    } flags;
+                } ufs;
+            } type;
+        };
+</verb>
 
-<!-- %%%% Chapter : CLIENT REQUEST PROCESSING %%%% -->
-<sect>Processing Client Requests
+	<em/swap_file_number/ is the 32-bit swap file number for the
+	object, taken from the <em/StoreEntry/.
+
+	<em/mode/ is either O_RDONLY or O_WRONLY.
+
+	<em/offset/ represents the file (byte) offset after the
+	last operation completed.  For example, after a read operation,
+	<em/offset/ must be incremented by the number of bytes read.
+	The same goes for write operations.  This means that the
+	filesystem layer needs explicit (callback) notification
+	for writes.  It is wrong to increment <em/offset/ before
+	an I/O operation has been known to succeed.
+
+	<em/st_size/ is filled in with the object's on-disk size
+	after an object is opened for reading.  This allows
+	the upper layers to double-check that the disk object
+	actually belongs to the StoreEntry.
+
+	Note that there are two callback functions.  The first,
+	<em/callback/, of type <em/STIOCB/ (store I/O callback),
+	is callback for the <em/storeIOState/ as a whole.  This
+	callback is used to indicate success or failure of accessing
+	the object, whether its for reading or writing.
+	There are no callbacks for open and write operations,
+	unless they fail.
+
+	The second, <em/read.callback/, of type <em/STRCB/ (store
+	read callback) is used for every read operation.
+
+	The ugly union is used to hold filesystem-specific state
+	information.
+
+	<em/storeIOState/ structures are allocated by calling
+	<tt/storeOpen()/, and will be deallocated by the
+	filesystem layer after
+	<tt/storeClose()/ is called.
+
+<sect2>External Functions
+
+<sect3>Object I/O
+
+	<P>
+	These functions all relate to per-object I/O tasks: opening,
+	closing, reading, writing, and unlinking objects on disk.
+	These functions can all be found in <tt/store_io.c/.
+
+	<P>
+	Note that the underlying storage system functions are
+	accessed through function pointers, kept in the
+	<em/SwapDir/ structure:
+<verb>
+    struct _SwapDir {
+	....
+        struct {
+            STOBJOPEN *open;
+            STOBJCLOSE *close;
+            STOBJREAD *read;
+            STOBJWRITE *write;
+            STOBJUNLINK *unlink;
+        } obj;
+	....
+    };
+</verb>
+
+	<P>
+	Thus, a storage system must do something like this
+	when initializing its <em/SwapDir/ structure:
+<verb>
+            SwapDir->obj.open = storeFooOpen;
+            SwapDir->obj.close = storeFooClose;
+            SwapDir->obj.read = storeFooRead;
+            SwapDir->obj.write = storeFooWrite;
+            SwapDir->obj.unlink = storeFooUnlink;
+</verb>
+
+<sect4><tt/storeOpen()/
+
+	<P>
+<verb>
+	storeIOState *
+	storeOpen(sfileno f, mode_t mode, STIOCB *callback, void *callback_data)
+</verb>
+
+	<P>
+	<tt/storeOpen()/
+	submits a request to open a cache object for reading or writing.
+	<tt/f/ is the 32-bit swap file number of the cached object.
+	<tt/mode/ should be either <tt/O_RDONLY/ or <tt/O_WRONLY/.
+
+	<P>
+	<tt/callback/ is a function that will be called either when
+	an error is encountered, or when the object is closed (by
+	calling <tt/storeClose()/).  If the open request is
+	successful, there is no callback.  The calling module must
+	assume the open request will succeed, and may begin reading
+	or writing immediately.
+
+	<P>
+	<tt/storeOpen()/ may return NULL if the requested object
+	can not be openeed.  In this case the <tt/callback/ function
+	will not be called.
+
+<sect4><tt/storeClose()/
+
+	<P>
+<verb>
+	void
+	storeClose(storeIOState *sio)
+</verb>
+
+	<P>
+	<tt/storeClose()/
+	submits a request to close the cache object.  It is safe to request
+	a close even if there are read or write operations pending.
+	When the underlying filesystem actually closes the object,
+	the <em/STIOCB/ callback (registered with <tt/storeOpen()/) will
+	be called.
+
+<sect4><tt/storeRead()/
+
+	<P>
+<verb>
+	void
+	storeRead(storeIOState *sio, char *buf, size_t size, off_t offset, STRCB *callback, void *callback_data)
+</verb>
+
+	<P>
+	<tt/storeRead()/ is more complicated than the other functions
+	because it requires its own callback function to notify the
+	caller when the requested data has actually been read. 
+	<em/buf/ must be a valid memory buffer of at least <em/size/
+	bytes.  <em/offset/ specifies the byte offset where the
+	read should begin.  Note that with the Swap Meta Headers
+	prepended to each cache object, this offset does not equal
+	the offset into the actual object data.
+
+	<P>
+	The caller is responsible for allocating and freeing <em/buf/
+
+<sect4><tt/storeWrite()/
+
+	<P>
+<verb>
+	void
+	storeWrite(storeIOState *sio, char *buf, size_t size, off_t offset, FREE *free_func)
+</verb>
+
+	<P>
+	<tt/storeWrite()/ submits a request to write a block
+	of data to the disk store.  
+	The caller is responsible for allocating <em/buf/, but since
+	there is no per-write callback, this memory must be freed by
+	the lower filesystem implementation.  Therefore, the caller
+	must specify the <em/free_func/ to be used to deallocate
+	the memory.
+
+	<P>
+	If a write operation fails, the filesystem layer notifies the
+	calling module by calling the <em/STIOCB/ callback with an
+	error status code.
+
+<sect4><tt/storeUnlink()/
+
+	<P>
+<verb>
+	void
+	storeUnlink(sfileno f)
+</verb>
+
+	<P>
+	<tt/storeUnlink()/ removes the cached object from the disk
+	store.  There is no callback function, and the object
+	does not need to be opened first.  The filesystem
+	layer will remove the object if it exists on the disk.
+
+<sect4><tt/storeOffset()/
+
+	<P>
+<verb>
+	off_t
+	storeOffset(storeIOState *sio)
+</verb>
+
+	<P>
+	Returns the current byte-offset of the cache object on
+	disk.  For read-objects, this is the offset after the last
+	successful disk read operation.  For write-objects, it is
+	the offset of the last successful disk write operation.
+
+<sect4><em/STIOCB/ callback
+
+	<P>
+<verb>
+	void
+	stiocb(void *data, int errorflag, storeIOState *sio)
+</verb>
+
+	<P>
+	The <em/stiocb/ function is passed as a parameter to
+	<tt/storeOpen()/.  The filesystem layer calls <em/stiocb/
+	either when an I/O error occurs, or when the disk
+	object is closed.
+
+	<P>
+	<em/errorflag/ is one of the following:
+<verb>
+	#define DISK_OK                   (0)
+	#define DISK_ERROR               (-1)
+	#define DISK_EOF                 (-2)
+	#define DISK_NO_SPACE_LEFT       (-6)
+</verb>
+
+	<P>
+	Once the The <em/stiocb/ function has been called,
+	the <em/sio/ structure should not be accessed further.
+
+<sect4><em/STRCB/ callback
+
+	<P>
+<verb>
+	void
+	strcb(void *data, const char *buf, size_t len)
+</verb>
+
+	<P>
+	The <em/strcb/ function is passed as a parameter to
+	<tt/storeRead()/.  The filesystem layer calls <em/strcb/
+	after a block of data has been read from the disk and placed
+	into <em/buf/.  <em/len/ indicates how many bytes were
+	placed into <em/buf/.  The <em/strcb/ function is only
+	called if the read operation is successful.  If it fails,
+	then the <em/STIOCB/ callback will be called instead.
+
+<sect3>Config file parsing
+
+	<P>
+	There are three functions relating to the Squid configuration
+	file: parsing, dumping, and freeing.
+
+	<P>
+	The parse function is called at startup, and during a reconfigure,
+	for a <em/cache_dir/ line.  The first keyword after the <em/cache_dir/
+	keyword will be a filesystem type (such as "ufs").  A switch
+	statement in <tt/parse_cachedir/ will call the appropriate
+	filesystem-dependent parsing function.  The parsing function
+	may use <tt/strtok()/ to continue reading keywords after the
+	filesystem type on the <em/cache_dir/ line.
+
+
+	<P>
+	The ``dump'' function is used to output a configuration
+	file from the in-memory configuration structure.  It is
+	called with a <em/SwapDir/ argument, and must append one
+	line to the <em/StoreEntry/ that is holding the configuration
+	file being generated.
+
+	<P>
+	The free function is called during a reconfigure (and at
+	exit) to free up (or un-initialize) any memory or structures
+	associated with the configuration line.  The <em/SwapDir/
+	structure includes common and private sections.  The
+	<tt/free_cachedir()/ function will handle freeing anything
+	in the common section, and relies on a filesystem-dependent
+	function to free, or un-initialize private members.
+
+<sect3>Filesystem Startup, Initialization, and State Logging
+
+	<P>
+	These functions deal with initializing, state
+	logging, and related tasks for a squid storage system.
+	These functions are used (called) in <tt/store_dir.c/.
+
+	<P>
+	Each storage system must provide the functions described
+	in this section, although it may be a no-op (null) function
+	that does nothing.  Each function is accessed through a
+	function pointer stored in the <em/SwapDir/ structure:
+
+<verb>
+    struct _SwapDir {
+        ...
+        STINIT *init;
+        STNEWFS *newfs;
+        struct {
+            STLOGOPEN *open;
+            STLOGCLOSE *close;
+            STLOGWRITE *write;
+            struct {
+                STLOGCLEANOPEN *open;
+                STLOGCLEANWRITE *write;
+                void *state;
+            } clean;
+        } log;
+        ....
+    };
+</verb>
+
+<sect4><tt/init()/
+
+	<P>
+<verb>
+        void
+        STINIT(SwapDir *);
+</verb>
+
+	<P>
+	The <tt/init/ function, of type <em/STINIT/ is called by
+	<tt/storeDirInit()/ when Squid first starts up.  The
+	<tt/init/ function should probably start the process of
+	reading saved state information from disk (aka the "rebuild"
+	procedure).
+
+<sect4><tt/newfs()/
+
+	<P>
+<verb>
+	void
+	STNEWFS(SwapDir *);
+</verb>
+
+	<P>
+	The <tt/newfs/ function, of type <em/STNEWFS/, is used to
+	prepare a cache_dir for use by squid.  It is called when
+	the user runs <em/squid -z/.  For the Unix file system,
+	the <tt/newfs/ function makes all the two-layer subdirectories.
+
+<sect4><tt/log.open()/
+
+	<P>
+<verb>
+	void
+	STLOGOPEN(SwapDir *);
+</verb>
+
+	<P>
+	The <tt/log.open/ function, of type <em/STLOGOPEN/,
+	is used to open or initialize the state-holding log
+	files (if any) for the storage system.  For UFS this
+	opens the <em/swap.state/ files.
+
+	<P>
+	The <tt/log.open/ function may be called any number of
+	times during Squid's execution.  For example, the
+	process of rotating, or writing clean logfiles closes
+	the state log and then re-opens them.  A <em/squid -k reconfigure/
+	does the same.
+
+<sect4><tt/log.close()/
+
+	<P>
+<verb>
+	void
+	STLOGCLOSE(SwapDir *);
+</verb>
+
+	<P>
+	The <tt/log.close/ function, of type <em/STLOGCLOSE/, is
+	obviously the counterpart to <tt/log.open/.  It must close
+	the open state-holding log files (if any) for the storage
+	system.
+
+<sect4><tt/log.write()/
+
+	<P>
+<verb>
+	void
+	STLOGWRITE(const SwapDir *, const StoreEntry *, int op);
+</verb>
+
+	<P>
+	The <tt/log.write/ function, of type <em/STLOGWRITE/, is
+	used to write an entry to the state-holding log file.  The
+	<em/op/ argument is either <em/SWAP_LOG_ADD/ or <em/SWAP_LOG_DEL/.
+	This feature may not be required by some storage systems
+	and can be implemented as a null-function (no-op).
+
+<sect4><tt/log.clean.open()/
+
+	<P>
+<verb>
+	int
+	STLOGCLEANOPEN(SwapDir *);
+</verb>
+
+	<P>
+	The <tt/log.clean.open/ function, of type <em/STLOGCLEANOPEN/,
+	is used for the process of writing "clean" state-holding
+	log files.  The clean-writing procedure is initiated by
+	the <em/squid -k rotate/ command.  This is a special case
+	because we want to optimize the process as much as possible.
+	This might be a no-op for some storage systems that don't
+	have the same logging issues as UFS.
+
+	<P>
+	The <em/log.clean.state/ pointer may be used to
+	keep state information for the clean-writing process, but
+	should not be accessed by upper layers.
+
+<sect4><tt/log.clean.write()/
+
+	<P>
+<verb>
+	void
+	STLOGCLEANWRITE(const StoreEntry *, SwapDir *);
+</verb>
+
+	<P>
+	The <tt/log.clean.write/ function, of type <em/STLOGCLEANWRITE/,
+	writes an entry to the clean log file (if any).
+
+	<P>
+	A NULL <em/StoreEntry/ argument indicates the end of
+	the clean-writing process and signals the storage
+	system to close the clean log, and rename or move them
+	to become the official state-holding log.
 
-<!-- %%%% Chapter : STORAGE MANAGER %%%% -->
-<sect>Storage Manager
 
 <!-- %%%% Chapter : FORWARDING SELECTION %%%% -->
 <sect>Forwarding Selection
